module Embulk
  module Output

    class Mongodb < OutputPlugin
      require 'mongo'
      Plugin.register_output('mongodb', self)

      def self.transaction(config, schema, count, &control)
        # configuration code:
        task = {
          'uri' => config.param('uri', :string, default: 'mongodb://127.0.0.1:27017/test'), # string, optional
          'collection' => config.param('collection', :string)           # string, required
        }

        # resumable output:
        # resume(task, schema, count, &control)

        # non-resumable output:
        task_reports = yield(task)
        next_config_diff = {}
        return next_config_diff
      end

      #def self.resume(task, schema, count, &control)
      #  task_reports = yield(task)
      #
      #  next_config_diff = {}
      #  return next_config_diff
      #end

      def init
        # initialization code:
        @client = Mongo::Client.new(task['uri'])
        @collection = @client[task['collection']]
      end

      def close
      end

      def add(page)
        # output code:
        page.each do |record|
          hash = Hash[schema.names.zip(record)]
          @collection.insert_one(hash)
        end
      end

      def finish
      end

      def abort
      end

      def commit
        task_report = {}
        return task_report
      end
    end

  end
end
